! package output
!     for 2-D thermal convection in a square box. 
!
! 99/05/04  S. Takehiro
! 99/08/19  S. Takehiro  close a netcdf file in each output. 
!
!===============================  ===============================
module output
  use namelist
  use output_netcdf
  use output_dcl

  implicit none
  integer              :: iws = 1      ! ɽˡ(0:ե, 1-3:DCL)
  character(len=80)    :: file=''

  private
  public     :: output_init, output_data, output_close
   
  contains
   !----------------------------  ----------------------------
    subroutine output_init
      namelist  /NMOUT/  iws, file

      if( .not. rewnml() ) write( nm_write_num, NML=NMOUT )
      read( nm_read_num, NML=NMOUT, end=999 )
 999  write( nm_write_num, NML=NMOUT )

      if ( iws .eq. 0 ) then 
         call output_netcdf_init( file )
      else
         call output_dcl_init( iws )
      endif
    end subroutine output_init

   !-----------------------------  -----------------------------
    subroutine output_data
      if ( iws .eq. 0 ) then
         call output_netcdf_data( file )
      else
         call output_dcl_data
      endif
    end subroutine output_data

   !--------------------------  ------------------------------
    subroutine output_close
      if ( iws .eq. 0 ) then
         !call output_netcdf_close
      else
         call output_dcl_close
      endif
    end subroutine output_close

end module output
